% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
%
% boot loader splash code
%
% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


% Boot loader splash areas to uncover.
%
/bsplash.areas [
  [   0   0  160  44  320 320  true  ]
  [ 320   0  160  44  320 320  true  ]
  [ 640   0  160  44  320 320  true  ]
  [  10 320  170 360   48  48  false ]
  [  58 320  208 360   48  48  false ]
  [ 106 320  246 360   48  48  false ]
  [ 154 320  284 360   28  48  false ]
  [ 182 320  302 360   40  48  false ]
  [ 222 320  332 360   28  48  false ]
  [ 250 320  350 360   44  48  false ]
  [ 294 320  384 360   44  48  false ]
  [ 338 320  418 360   48  48  false ]
  [  14 370  174 410   14  14  false ]
  [  38 370  198 410   14  14  false ]
  [  56 370  216 410   14  14  false ]
  [  78 370  238 410   14  14  false ]
  [ 110 370  270 410   14  14  false ]
  [ 130 370  290 410   14  14  false ]
  [ 166 370  326 410   14  14  false ]
  [ 188 370  348 410   14  14  false ]
  [ 208 370  368 410   14  14  false ]
  [ 228 370  388 410   14  14  false ]
  [ 250 370  410 410   14  14  false ]
  [ 270 370  430 410   14  14  false ]
  [ 290 370  450 410   14  14  false ]
] def


% start value
/rand.start time def


% Generate pseudo random number.
% Good enough for boot loader splash screen.
%
% ( ) ==> ( int )
%
/rand {
  rand.start 59 mul 97 add 0x7fffffff and
  /rand.start over def
} def

% Show boot loader splash.
%
% ( ) ==> ( )
%
/bsplash.show {
  1 activateimage loadpalette
  /max_image_colors max_image_colors image.colors max def

  -1 -1 0 fillmode
  0 0 moveto getpixel dup settransparentcolor setcolor
  0 0 moveto screen.size fillrect
  500000 usleep

  0 1 2 {
    bsplash.areas exch get
    dup 2 get over 3 get moveto
    dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
    700000 usleep
  } for
  300000 usleep

  {
    bsplash.areas rand 9 mod 3 add get
    dup 6 get {
      pop
    } {
      dup 6 true put
      dup 2 get over 3 get moveto
      dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
      50000 usleep
    } ifelse
    true
    3 1 11 {
      bsplash.areas exch get 6 get and
    } for
    { exit } if
  } loop
  {
    bsplash.areas rand 13 mod 12 add get
    dup 6 get {
      pop
    } {
      dup 6 true put
      dup 2 get over 3 get moveto
      dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
      50000 usleep
    } ifelse

    true
    12 1 24 {
      bsplash.areas exch get 6 get and
    } for
    { exit } if
  } loop

  4000000 usleep
  0 activateimage
  -1 settransparentcolor
} def


% Just wait.
%
% ( ) ==> ( )
%
/bsplash.done {
} def
